#define USE_ARDUINO_INTERRUPTS true
#include <PulseSensorPlayground.h>

#include <LiquidCrystal_I2C.h>
#include <SHT21.h>

LiquidCrystal_I2C lcd(0x27, 16, 2);

PulseSensorPlayground pulseSensor;
SHT21 sht;

const int PulseWire = 0;
const int buttonPin = 2;
int Threshold = 520;           // Determine which Signal to "count as a beat" and which to ignore

float Humidity;
int buttonState = 0;

int i = 0;
int v[20];

float averageHeartRate;

void setup() {
  Serial.begin(9600);         
  // Configure the PulseSensor object, by assigning our variables to it
  pulseSensor.analogInput(PulseWire);
  pulseSensor.setThreshold(Threshold); 

  pulseSensor.begin();  
  Wire.begin();  
  lcd.init();
 
  lcd.backlight();

  pinMode(7, OUTPUT);
  pinMode(8, OUTPUT);
  pinMode(buttonPin, INPUT);

}

void loop() {
  Humidity = sht.getHumidity();
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Ready?"); 
  buttonState = digitalRead(buttonPin);
  if (i != 100)
    Serial.println(i);
  if (buttonState == HIGH && i > 20){  
    lcd.clear();
    int myBPM = pulseSensor.getBeatsPerMinute();
    if ( myBPM > 50 && myBPM < 180 ) {
      delay(1000);
      Serial.print("BPM: ");
      Serial.println(myBPM);
      if (Humidity > 60 || (averageHeartRate + 10 < myBPM 
                              || averageHeartRate - 10 > myBPM)) {
       lcd.setCursor(0,0);
       lcd.print("Liar"); 
       digitalWrite(7, HIGH);
       digitalWrite(8, LOW);
      } else {
       lcd.setCursor(0,0);
       lcd.print("Telling the"); 
       lcd.setCursor(0,1);
       lcd.print("truth?");
       digitalWrite(8, HIGH);
       digitalWrite(7, LOW);
      }
    }
  } else if (i < 20) {
    int myBPM = pulseSensor.getBeatsPerMinute();
    if (myBPM > 50 && myBPM < 180) {
      Serial.print("BPM: ");
      Serial.println(myBPM);
      
      v[i] = myBPM;
      i++;
    }
  } else if (i == 20) {
    int sum = 0;
    for (int j = 0; j < 20; j++)
      sum += v[j];
    averageHeartRate = sum / 20;
    Serial.print("Average: ");
    Serial.println(averageHeartRate);
    i = 100;
  }
  delay(5000);
}
